Index: /trunk/libc/src/kNIX/b_fhImport.c
===================================================================
--- /trunk/libc/src/kNIX/b_fhImport.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_fhImport.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - _imphandle().
  *
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_fsDirRemove.c
===================================================================
--- /trunk/libc/src/kNIX/b_fsDirRemove.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_fsDirRemove.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - rmdir.
  *
- * Copyright (c) 2004 knut st. osmundsen <bird-src-spam@innotek.de>
+ * Copyright (c) 2004 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_fsFileModeSet.c
===================================================================
--- /trunk/libc/src/kNIX/b_fsFileModeSet.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_fsFileModeSet.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - chmod().
  *
- * Copyright (c) 2005 knut st. osmundsen <bird@anduin.net>
+ * Copyright (c) 2005 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_fsFileStat.c
===================================================================
--- /trunk/libc/src/kNIX/b_fsFileStat.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_fsFileStat.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - stat().
  *
- * Copyright (c) 2004 knut st. osmundsen <bird-src-spam@innotek.de>
+ * Copyright (c) 2004 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_fsFileTimesSet.c
===================================================================
--- /trunk/libc/src/kNIX/b_fsFileTimesSet.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_fsFileTimesSet.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - utimes().
  *
- * Copyright (c) 2005 knut st. osmundsen <bird@anduin.net>
+ * Copyright (c) 2005 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_fsFileTimesSetFH.c
===================================================================
--- /trunk/libc/src/kNIX/b_fsFileTimesSetFH.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_fsFileTimesSetFH.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - futimes, OS/2.
  *
- * Copyright (c) 2005-2006 knut st. osmundsen <bird-src-spam@innotek.de>
+ * Copyright (c) 2005-2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_fsPathResolve.c
===================================================================
--- /trunk/libc/src/kNIX/b_fsPathResolve.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_fsPathResolve.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - realpath.
  *
- * Copyright (c) 2004-2006 knut st. osmundsen <bird-src-spam@innotek.de>
+ * Copyright (c) 2004-2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_fsSymlinkCreate.c
===================================================================
--- /trunk/libc/src/kNIX/b_fsSymlinkCreate.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_fsSymlinkCreate.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - symlink.
  *
- * Copyright (c) 2004 knut st. osmundsen <bird-src-spam@innotek.de>
+ * Copyright (c) 2004 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_fsSymlinkModeSet.c
===================================================================
--- /trunk/libc/src/kNIX/b_fsSymlinkModeSet.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_fsSymlinkModeSet.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - lchmod().
  *
- * Copyright (c) 2005 knut st. osmundsen <bird@anduin.net>
+ * Copyright (c) 2005 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_fsSymlinkRead.c
===================================================================
--- /trunk/libc/src/kNIX/b_fsSymlinkRead.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_fsSymlinkRead.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - readlink.
  *
- * Copyright (c) 2004 knut st. osmundsen <bird-src-spam@innotek.de>
+ * Copyright (c) 2004 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_fsSymlinkStat.c
===================================================================
--- /trunk/libc/src/kNIX/b_fsSymlinkStat.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_fsSymlinkStat.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - lstat.
  *
- * Copyright (c) 2004 knut st. osmundsen <bird-src-spam@innotek.de>
+ * Copyright (c) 2004 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_fsSymlinkTimesSet.c
===================================================================
--- /trunk/libc/src/kNIX/b_fsSymlinkTimesSet.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_fsSymlinkTimesSet.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - lutimes().
  *
- * Copyright (c) 2005-2006 knut st. osmundsen <bird@anduin.net>
+ * Copyright (c) 2005-2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_initterm.c
===================================================================
--- /trunk/libc/src/kNIX/b_initterm.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_initterm.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - Process init.
  *
- * Copyright (c) 2006 knut st. osmundsen <bird@innotek.de>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_ioClose.c
===================================================================
--- /trunk/libc/src/kNIX/b_ioClose.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_ioClose.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - close.
  *
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_ioControl.c
===================================================================
--- /trunk/libc/src/kNIX/b_ioControl.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_ioControl.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - ioctl().
  *
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_ioDirGetEntries.c
===================================================================
--- /trunk/libc/src/kNIX/b_ioDirGetEntries.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_ioDirGetEntries.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - getdirentries().
  *
- * Copyright (c) 2005-2006 knut st. osmundsen <bird-src-spam@innotek.de>
+ * Copyright (c) 2005-2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_ioDuplicate.c
===================================================================
--- /trunk/libc/src/kNIX/b_ioDuplicate.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_ioDuplicate.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - dup() and dup2().
  *
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_ioFHToPath.c
===================================================================
--- /trunk/libc/src/kNIX/b_ioFHToPath.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_ioFHToPath.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - __libc_Back_fhToPath().
  *
- * Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2004-2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_ioFileControl.c
===================================================================
--- /trunk/libc/src/kNIX/b_ioFileControl.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_ioFileControl.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - fcntl().
  *
- * Copyright (c) 2003-2006 knut st. osmundsen <bird-src-spam@innotek.de>
+ * Copyright (c) 2003-2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_ioFileSizeSet.c
===================================================================
--- /trunk/libc/src/kNIX/b_ioFileSizeSet.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_ioFileSizeSet.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - _chsize() / ftruncate().
  *
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_ioRead.c
===================================================================
--- /trunk/libc/src/kNIX/b_ioRead.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_ioRead.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - read().
  *
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_ioSeek.c
===================================================================
--- /trunk/libc/src/kNIX/b_ioSeek.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_ioSeek.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - seek().
  *
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_ioSync.c
===================================================================
--- /trunk/libc/src/kNIX/b_ioSync.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_ioSync.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - fsync().
  *
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_ioTTYName.c
===================================================================
--- /trunk/libc/src/kNIX/b_ioTTYName.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_ioTTYName.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - ttyname_r.
  *
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_ioWrite.c
===================================================================
--- /trunk/libc/src/kNIX/b_ioWrite.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_ioWrite.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - write().
  *
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_mmanBrk.c
===================================================================
--- /trunk/libc/src/kNIX/b_mmanBrk.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_mmanBrk.c	(revision 2927)
@@ -5,5 +5,5 @@
  *
  * Copyright (c) 1992-1996 by Eberhard Mattes
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_mmanSBrk.c
===================================================================
--- /trunk/libc/src/kNIX/b_mmanSBrk.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_mmanSBrk.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - sbrk().
  *
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_mmanSBrkGetModel.c
===================================================================
--- /trunk/libc/src/kNIX/b_mmanSBrkGetModel.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_mmanSBrkGetModel.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - get sbrk() model.
  *
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_mmanSBrkSetModel.c
===================================================================
--- /trunk/libc/src/kNIX/b_mmanSBrkSetModel.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_mmanSBrkSetModel.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - set sbrk() model.
  *
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_processGetResourceLimit.c
===================================================================
--- /trunk/libc/src/kNIX/b_processGetResourceLimit.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_processGetResourceLimit.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - getrlimit().
  *
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_processSetResourceLimit.c
===================================================================
--- /trunk/libc/src/kNIX/b_processSetResourceLimit.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_processSetResourceLimit.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - setrlimit().
  *
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/b_signalSendPid.c
===================================================================
--- /trunk/libc/src/kNIX/b_signalSendPid.c	(revision 2926)
+++ /trunk/libc/src/kNIX/b_signalSendPid.c	(revision 2927)
@@ -4,5 +4,5 @@
  * LIBC SYS Backend - send signal to process.
  *
- * Copyright (c) 2004 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2004 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/filehandles.c
===================================================================
--- /trunk/libc/src/kNIX/filehandles.c	(revision 2926)
+++ /trunk/libc/src/kNIX/filehandles.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX File Handles.
  *
- * Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2004-2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
@@ -635,5 +635,5 @@
     FS_RESTORE();
     if (rc > 0)
-        rc = -__libc_native2errno(rc);
+        rc = -__libc_back_native2errno(rc);
     return rc;
 # endif /* __OS2__ */
@@ -780,5 +780,5 @@
 
     if (rc > 0)
-        rc = -__libc_native2errno(rc);
+        rc = -__libc_back_native2errno(rc);
     return rc;
 # endif /* __OS2__ */
@@ -1387,5 +1387,5 @@
     }
 
-    rc = -__libc_native2errno(rc);
+    rc = -__libc_back_native2errno(rc);
     LIBCLOG_ERROR_RETURN_INT(rc);
 
@@ -1472,5 +1472,5 @@
                                                         (void *)pFH->pOps->pfnForkParent, iFH, rc);
                                     if (rc > 0)
-                                        rc = -__libc_native2errno(rc);
+                                        rc = -__libc_back_native2errno(rc);
                                     break;
                                 }
@@ -1492,5 +1492,5 @@
                                 {
                                     LIBC_ASSERTM_FAILED("DosSetFHState or DosQueryFHState failed with rc=%d for handle %d\n", rc, iFH);
-                                    rc = -__libc_native2errno(rc);
+                                    rc = -__libc_back_native2errno(rc);
                                     break;
                                 }
@@ -1504,5 +1504,5 @@
             {
                 LIBC_ASSERTM_FAILED("failed to get the filehandle mutex. rc=%d\n", rc);
-                rc = -__libc_native2errno(rc);
+                rc = -__libc_back_native2errno(rc);
             }
             break;
@@ -1531,5 +1531,5 @@
                                                 (void *)pFH->pOps->pfnForkParent, iFH, rc);
                             if (rc > 0)
-                                rc = -__libc_native2errno(rc);
+                                rc = -__libc_back_native2errno(rc);
                             break;
                         }
@@ -1595,5 +1595,5 @@
                                                 (void *)pFH->pOps->pfnForkChild, iFH, rc);
                             if (rc > 0)
-                                rc = -__libc_native2errno(rc);
+                                rc = -__libc_back_native2errno(rc);
                             break;
                         }
@@ -1622,5 +1622,5 @@
                 LIBC_ASSERTM_FAILED("_fmutex_release failed rc=%d\n", rc2);
                 if (rc >= 0)
-                    rc = -__libc_native2errno(rc2);
+                    rc = -__libc_back_native2errno(rc2);
             }
             gfForkCleanupDone = 1;
Index: /trunk/libc/src/kNIX/fs.c
===================================================================
--- /trunk/libc/src/kNIX/fs.c	(revision 2926)
+++ /trunk/libc/src/kNIX/fs.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - file system, common bits.
  *
- * Copyright (c) 2004-2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2004-2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/heap.c
===================================================================
--- /trunk/libc/src/kNIX/heap.c	(revision 2926)
+++ /trunk/libc/src/kNIX/heap.c	(revision 2927)
@@ -5,5 +5,5 @@
  *
  * Copyright (c) 1996 by Eberhard Mattes
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/heapdata.c
===================================================================
--- /trunk/libc/src/kNIX/heapdata.c	(revision 2926)
+++ /trunk/libc/src/kNIX/heapdata.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - heap data.
  *
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/kNIX.h
===================================================================
--- /trunk/libc/src/kNIX/kNIX.h	(revision 2926)
+++ /trunk/libc/src/kNIX/kNIX.h	(revision 2927)
@@ -4,5 +4,5 @@
  * kNIX - Main header.
  *
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@anduin.net>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *
Index: /trunk/libc/src/kNIX/thread.c
===================================================================
--- /trunk/libc/src/kNIX/thread.c	(revision 2926)
+++ /trunk/libc/src/kNIX/thread.c	(revision 2927)
@@ -4,5 +4,5 @@
  * kUNIX - Thread Management.
  *
- * Copyright (c) 2006 knut st. osmundsen <bird-srcspam@innotek.de>
+ * Copyright (c) 2006 knut st. osmundsen <bird-src-spam@anduin.net>
  *
  *